diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/linux/net.c olsrd-current/src/linux/net.c
--- olsrd-0.5.0/src/linux/net.c	2007-02-05 00:36:35.000000000 +0100
+++ olsrd-current/src/linux/net.c	2007-04-26 00:08:18.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net.c,v 1.32 2007/02/04 23:36:35 bernd67 Exp $
+ * $Id: net.c,v 1.34 2007/04/25 22:08:18 bernd67 Exp $
  */
 
 
@@ -76,9 +76,8 @@
   /*
    *Bind to device using the SO_BINDTODEVICE flag
    */
-  OLSR_PRINTF(3, "Binding socket %d to device %s\n", sock, dev_name)
+  OLSR_PRINTF(3, "Binding socket %d to device %s\n", sock, dev_name);
   return setsockopt(sock, SOL_SOCKET, SO_BINDTODEVICE, dev_name, strlen(dev_name)+1);
-
 }
 
 
@@ -98,20 +97,9 @@
 enable_ip_forwarding(int version)
 {
   FILE *proc_fwd;
-  char procfile[FILENAME_MAX];
-
-  if(version == AF_INET)
-    {
-      strncpy(procfile, "/proc/sys/net/ipv4/ip_forward", FILENAME_MAX);
-    }
-  else
-    if(version == AF_INET6)
-      {
-	strncpy(procfile, "/proc/sys/net/ipv6/conf/all/forwarding", FILENAME_MAX);
-      }
-    else
-      return -1;
-
+  const char * const procfile = version == AF_INET
+      ? "/proc/sys/net/ipv4/ip_forward"
+      : "/proc/sys/net/ipv6/conf/all/forwarding";
 
   if ((proc_fwd=fopen(procfile, "r"))==NULL)
     {
@@ -126,48 +114,40 @@
       return 0;
     }
   
+  orig_fwd_state = fgetc(proc_fwd);
+  fclose(proc_fwd);
+  if(orig_fwd_state == '1')
+    {
+      OLSR_PRINTF(3, "\nIP forwarding is enabled on this system\n");
+    }
   else
     {
-      orig_fwd_state = fgetc(proc_fwd);
-      fclose(proc_fwd);
-      if(orig_fwd_state == '1')
-	{
-	  OLSR_PRINTF(3, "\nIP forwarding is enabled on this system\n")
-	}
+      if ((proc_fwd=fopen(procfile, "w"))==NULL)
+        {
+          fprintf(stderr, "Could not open %s for writing!\n", procfile);
+          fprintf(stderr, "I will continue(in 3 sec) - but you should mannually ensure that IP forwarding is enabeled!\n\n");
+          sleep(3);
+          return 0;
+        }
       else
-	{
-	  if ((proc_fwd=fopen(procfile, "w"))==NULL)
-	    {
-	      fprintf(stderr, "Could not open %s for writing!\n", procfile);
-	      fprintf(stderr, "I will continue(in 3 sec) - but you should mannually ensure that IP forwarding is enabeled!\n\n");
-	      sleep(3);
-	      return 0;
-	    }
-	  else
-	    {
-	      syslog(LOG_INFO, "Writing \"1\" to %s\n", procfile);
-	      fputs("1", proc_fwd);
-	    }
-	  fclose(proc_fwd);
-
-	}
+        {
+          syslog(LOG_INFO, "Writing \"1\" to %s\n", procfile);
+          fputs("1", proc_fwd);
+        }
+      fclose(proc_fwd);
     }
-  return 1;
-      
+  return 1;      
 }
 
-
 int
 disable_redirects_global(int version)
 {
   FILE *proc_redirect;
-  char procfile[FILENAME_MAX];
+  const char * const procfile = "/proc/sys/net/ipv4/conf/all/send_redirects";
 
   if(version == AF_INET6)
     return -1;
 
-  strcpy(procfile, "/proc/sys/net/ipv4/conf/all/send_redirects");
-
   if((proc_redirect = fopen(procfile, "r")) == NULL)
     {
       fprintf(stderr, "WARNING! Could not open the %s file to check/disable ICMP redirects!\nAre you using the procfile filesystem?\nDoes your system support IPv4?\nI will continue(in 3 sec) - but you should mannually ensure that ICMP redirects are disabled!\n\n", procfile);
@@ -175,16 +155,11 @@
       sleep(3);
       return -1;
     }
-  else
-    {
-      orig_global_redirect_state = fgetc(proc_redirect);
-      fclose(proc_redirect);
-    }
+  orig_global_redirect_state = fgetc(proc_redirect);
+  fclose(proc_redirect);
 
   if(orig_global_redirect_state == '0')
-    {
       return 0;
-    }
 
   if ((proc_redirect = fopen(procfile, "w"))==NULL)
     {
@@ -193,17 +168,12 @@
       sleep(3);
       return 0;
     }
-  else
-    {
-      syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
-      fputs("0", proc_redirect);
-    }
-  fclose(proc_redirect);
-  
+  syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
+  fputs("0", proc_redirect);
+  fclose(proc_redirect);  
   return 1;
 }
 
-
 /**
  *
  *@return 1 on sucess 0 on failiure
@@ -218,22 +188,17 @@
     return -1;
 
   /* Generate the procfile name */
-  sprintf(procfile, REDIRECT_PROC, if_name);
+  snprintf(procfile, sizeof(procfile), REDIRECT_PROC, if_name);
 
 
   if((proc_redirect = fopen(procfile, "r")) == NULL)
     {
-      fprintf(stderr, "WARNING! Could not open the %s file to check/disable ICMP redirects!\nAre you using the procfile filesystem?\nDoes your system support IPv4?\nI will continue(in 3 sec) - but you should mannually ensure that ICMP redirects are disabled!\n\n", procfile);
-      
+      fprintf(stderr, "WARNING! Could not open the %s file to check/disable ICMP redirects!\nAre you using the procfile filesystem?\nDoes your system support IPv4?\nI will continue(in 3 sec) - but you should mannually ensure that ICMP redirects are disabled!\n\n", procfile);      
       sleep(3);
       return 0;
     }
-  else
-    {
-      iface->nic_state.redirect = fgetc(proc_redirect);
-      fclose(proc_redirect);
-      
-    }
+  iface->nic_state.redirect = fgetc(proc_redirect);
+  fclose(proc_redirect);      
 
   if ((proc_redirect = fopen(procfile, "w"))==NULL)
     {
@@ -242,18 +207,12 @@
       sleep(3);
       return 0;
     }
-  else
-    {
-      syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
-      fputs("0", proc_redirect);
-    }
+  syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
+  fputs("0", proc_redirect);
   fclose(proc_redirect);
-
   return 1;
 }
 
-
-
 /**
  *
  *@return 1 on sucess 0 on failiure
@@ -267,11 +226,9 @@
   if(version == AF_INET6)
     return -1;
 
-
   /* Generate the procfile name */
   sprintf(procfile, SPOOF_PROC, if_name);
 
-
   if((proc_spoof = fopen(procfile, "r")) == NULL)
     {
       fprintf(stderr, "WARNING! Could not open the %s file to check/disable the IP spoof filter!\nAre you using the procfile filesystem?\nDoes your system support IPv4?\nI will continue(in 3 sec) - but you should mannually ensure that IP spoof filtering is disabled!\n\n", procfile);
@@ -279,12 +236,8 @@
       sleep(3);
       return 0;
     }
-  else
-    {
-      iface->nic_state.spoof = fgetc(proc_spoof);
-      fclose(proc_spoof);
-      
-    }
+  iface->nic_state.spoof = fgetc(proc_spoof);
+  fclose(proc_spoof);
 
   if ((proc_spoof = fopen(procfile, "w")) == NULL)
     {
@@ -293,42 +246,29 @@
       sleep(3);
       return 0;
     }
-  else
-    {
-      syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
-      fputs("0", proc_spoof);
-    }
+  syslog(LOG_INFO, "Writing \"0\" to %s", procfile);
+  fputs("0", proc_spoof);
   fclose(proc_spoof);
-
   return 1;
 }
 
-
-
 /**
  *Resets the spoof filter and ICMP redirect settings
  */
-
 int
 restore_settings(int version)
 {
-  FILE *proc_fd;
-  char procfile[FILENAME_MAX];
   struct interface *ifs;
 
-  OLSR_PRINTF(1, "Restoring network state\n")
+  OLSR_PRINTF(1, "Restoring network state\n");
 
   /* Restore IP forwarding to "off" */
   if(orig_fwd_state == '0')
     {
-      if(version == AF_INET)
-	{
-	  strcpy(procfile, "/proc/sys/net/ipv4/ip_forward");
-	}
-      else if(version == AF_INET6)
-	{
-	  strcpy(procfile, "/proc/sys/net/ipv6/conf/all/forwarding");
-	}
+      const char * const procfile = version == AF_INET
+        ? "/proc/sys/net/ipv4/ip_forward"
+        : "/proc/sys/net/ipv6/conf/all/forwarding";
+      FILE *proc_fd;
 
       if ((proc_fd = fopen(procfile, "w")) == NULL)
 	{
@@ -340,7 +280,6 @@
 	  fputc(orig_fwd_state, proc_fd);
 	  fclose(proc_fd);
 	}
-
     }
 
   /* Restore global ICMP redirect setting */
@@ -348,7 +287,8 @@
     {
       if(version == AF_INET)
 	{
-	  strcpy(procfile, "/proc/sys/net/ipv4/conf/all/send_redirects");
+	  const char * const procfile = "/proc/sys/net/ipv4/conf/all/send_redirects";
+          FILE *proc_fd;
 
 	  if ((proc_fd = fopen(procfile, "w")) == NULL)
 	    {
@@ -363,24 +303,23 @@
 	}
     }
 
-
   if(version == AF_INET6)
     return 0;
 
   for(ifs = ifnet; ifs != NULL; ifs = ifs->int_next)
     {
+      char procfile[FILENAME_MAX];
+      FILE *proc_fd;
       /* Discard host-emulation interfaces */
       if(ifs->is_hcif)
 	continue;
       /* ICMP redirects */
       
       /* Generate the procfile name */
-      sprintf(procfile, REDIRECT_PROC, ifs->int_name);
+      snprintf(procfile, sizeof(procfile), REDIRECT_PROC, ifs->int_name);
       
       if ((proc_fd = fopen(procfile, "w")) == NULL)
-	{
 	  fprintf(stderr, "Could not open %s for writing!\nSettings not restored!\n", procfile);
-	}
       else
 	{
 	  syslog(LOG_INFO, "Resetting %s to %c\n", procfile, ifs->nic_state.redirect);
@@ -388,17 +327,13 @@
 	  fputc(ifs->nic_state.redirect, proc_fd);
 	  fclose(proc_fd);
 	}
-
       
       /* Spoof filter */
       
       /* Generate the procfile name */
       sprintf(procfile, SPOOF_PROC, ifs->int_name);
-
       if ((proc_fd = fopen(procfile, "w")) == NULL)
-	{
 	  fprintf(stderr, "Could not open %s for writing!\nSettings not restored!\n", procfile);
-	}
       else
 	{
 	  syslog(LOG_INFO, "Resetting %s to %c\n", procfile, ifs->nic_state.spoof);
@@ -406,13 +341,10 @@
 	  fputc(ifs->nic_state.spoof, proc_fd);
 	  fclose(proc_fd);
 	}
-
     }
   return 1;
-
 }
 
-
 /**
  *Creates a nonblocking broadcast socket.
  *@param sa sockaddr struct. Used for bind(2).
@@ -424,20 +356,18 @@
   int sock, on = 1;
 
   OLSR_PRINTF(1, "       Connecting to switch daemon port 10150...");
-
-
   if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
     {
       perror("hcsocket");
       syslog(LOG_ERR, "hcsocket: %m");
-      return (-1);
+      return -1;
     }
 
   if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0) 
     {
       perror("SO_REUSEADDR failed");
       close(sock);
-      return (-1);
+      return -1;
     }
   /* connect to PORT on HOST */
   if (connect(sock,(struct sockaddr *) pin, sizeof(*pin)) < 0) 
@@ -446,13 +376,13 @@
       fprintf(stderr, "Error connecting %d - %s\n", errno, strerror(errno));
       printf("connection refused\n");
       close(sock);
-      return (-1);
+      return -1;
     }
 
   printf("OK\n");
 
   /* Keep TCP socket blocking */  
-  return (sock);
+  return sock;
 }
 
 
@@ -467,24 +397,20 @@
   struct sockaddr_in *sin=(struct sockaddr_in *)sa;
   int sock, on = 1;
 
-
-
   if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
     {
       perror("socket");
       syslog(LOG_ERR, "socket: %m");
-      return (-1);
+      return -1;
     }
 
-
-
 #ifdef SO_BROADCAST
   if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, &on, sizeof (on)) < 0)
     {
       perror("setsockopt");
       syslog(LOG_ERR, "setsockopt SO_BROADCAST: %m");
       close(sock);
-      return (-1);
+      return -1;
     }
 #endif
 
@@ -492,17 +418,13 @@
     {
       perror("SO_REUSEADDR failed");
       close(sock);
-      return (-1);
+      return -1;
     }
 
-
-
 #ifdef SO_RCVBUF
-
   for (on = bufspace; ; on -= 1024) 
     {
-      if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF,
-		     &on, sizeof (on)) == 0)
+      if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF, &on, sizeof (on)) == 0)
 	break;
       if (on <= 8*1024) 
 	{
@@ -511,11 +433,8 @@
 	  break;
 	}
     }
-
-
 #endif
 
-
   /*
    * WHEN USING KERNEL 2.6 THIS MUST HAPPEN PRIOR TO THE PORT BINDING!!!!
    */
@@ -529,23 +448,21 @@
       return -1;
     }
 
-
   if (bind(sock, (struct sockaddr *)sin, sizeof (*sin)) < 0) 
     {
       perror("bind");
       syslog(LOG_ERR, "bind: %m");
       close(sock);
-      return (-1);
+      return -1;
     }
-
   /*
-   *One should probably fetch the flags first
+   *FIXME: One should probably fetch the flags first
    *using F_GETFL....
    */
   if (fcntl(sock, F_SETFL, O_NONBLOCK) == -1)
     syslog(LOG_ERR, "fcntl O_NONBLOCK: %m\n");
 
-  return (sock);
+  return sock;
 }
 
 
@@ -558,9 +475,6 @@
 getsocket6(struct sockaddr_in6 *sin, int bufspace, char *int_name)
 {
   int sock, on = 1;
-
-
-
   if ((sock = socket(AF_INET6, SOCK_DGRAM, 0)) < 0) 
     {
       perror("socket");
@@ -589,14 +503,10 @@
   */
   //#endif
 
-
-
-
 #ifdef SO_RCVBUF
   for (on = bufspace; ; on -= 1024) 
     {
-      if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF,
-		     &on, sizeof (on)) == 0)
+      if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF, &on, sizeof (on)) == 0)
 	break;
       if (on <= 8*1024) 
 	{
@@ -605,8 +515,6 @@
 	  break;
 	}
     }
-
-
 #endif
 
   if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0) 
@@ -616,7 +524,6 @@
       return (-1);
     }
 
-
   /*
    * WHEN USING KERNEL 2.6 THIS MUST HAPPEN PRIOR TO THE PORT BINDING!!!!
    */
@@ -630,7 +537,6 @@
       return -1;
     }
 
-
   if (bind(sock, (struct sockaddr *)sin, sizeof (*sin)) < 0) 
     {
       perror("bind");
@@ -638,7 +544,6 @@
       close(sock);
       return (-1);
     }
-
   /*
    *One should probably fetch the flags first
    *using F_GETFL....
@@ -646,12 +551,9 @@
   if (fcntl(sock, F_SETFL, O_NONBLOCK) == -1)
     syslog(LOG_ERR, "fcntl O_NONBLOCK: %m\n");
 
-
-
-  return (sock);
+  return sock;
 }
 
-
 int
 join_mcast(struct interface *ifs, int sock)
 {
@@ -663,7 +565,7 @@
   mcastreq.ipv6mr_interface = ifs->if_index;
 
 #if !defined __FreeBSD__ && !defined __MacOSX__ && !defined __NetBSD__
-  OLSR_PRINTF(3, "Interface %s joining multicast %s...",	ifs->int_name, olsr_ip_to_string((union olsr_ip_addr *)&ifs->int6_multaddr.sin6_addr))
+  OLSR_PRINTF(3, "Interface %s joining multicast %s...",	ifs->int_name, olsr_ip_to_string((union olsr_ip_addr *)&ifs->int6_multaddr.sin6_addr));
   /* Send multicast */
   if(setsockopt(sock, 
 		IPPROTO_IPV6, 
@@ -700,9 +602,8 @@
     {
       perror("Join multicast send");
       return -1;
-    }
+    }  
 
-  
   if(setsockopt(sock, 
 		IPPROTO_IPV6, 
 		IPV6_MULTICAST_IF, 
@@ -715,17 +616,14 @@
     }
 
 
-  OLSR_PRINTF(3, "OK\n")
+  OLSR_PRINTF(3, "OK\n");
   return 0;
 }
 
-
-
 /*
  *From net-tools lib/interface.c
  *
  */
-
 int
 get_ipv6_address(char *ifname, struct sockaddr_in6 *saddr6, int scope_in)
 {
@@ -747,13 +645,13 @@
 	      sprintf(addr6, "%s:%s:%s:%s:%s:%s:%s:%s",
 		      addr6p[0], addr6p[1], addr6p[2], addr6p[3],
 		      addr6p[4], addr6p[5], addr6p[6], addr6p[7]);
-	      OLSR_PRINTF(5, "\tinet6 addr: %s\n", addr6)
-	      OLSR_PRINTF(5, "\tScope: %d\n", scope)
+	      OLSR_PRINTF(5, "\tinet6 addr: %s\n", addr6);
+	      OLSR_PRINTF(5, "\tScope: %d\n", scope);
 	      if(scope == scope_in)
 		{
 		  OLSR_PRINTF(4, "Found addr: %s:%s:%s:%s:%s:%s:%s:%s\n",
 			      addr6p[0], addr6p[1], addr6p[2], addr6p[3],
-			      addr6p[4], addr6p[5], addr6p[6], addr6p[7])
+			      addr6p[4], addr6p[5], addr6p[6], addr6p[7]);
 		  inet_pton(AF_INET6,addr6,&tmp_sockaddr6);
 		  memcpy(&saddr6->sin6_addr, &tmp_sockaddr6, sizeof(struct in6_addr));	  
 		  fclose(f);
@@ -762,8 +660,7 @@
 	    }
 	}
       fclose(f);
-    }
-  
+    }  
   return 0;
 }
 
@@ -771,7 +668,6 @@
 /**
  * Wrapper for sendto(2)
  */
-
 ssize_t
 olsr_sendto(int s, 
 	    const void *buf, 
@@ -822,7 +718,7 @@
 }
 
 int
-check_wireless_interface(char *ifname)
+check_wireless_interface(char * ifname)
 {
   struct ifreq ifr;
 
@@ -884,11 +780,11 @@
       /* Get bit rate */
       if(ioctl(olsr_cnf->ioctl_s, SIOCGIWRATE, &ifr) < 0)
 	{
-	  OLSR_PRINTF(1, "Not able to find rate for WLAN interface %s\n", ifname)
+          OLSR_PRINTF(1, "Not able to find rate for WLAN interface %s\n", ifname);
 	  return WEIGHT_WLAN_11MB;
 	}
       
-      OLSR_PRINTF(1, "Bitrate %d\n", ifr.ifr_ifru.ifru_ivalue)
+      OLSR_PRINTF(1, "Bitrate %d\n", ifr.ifr_ifru.ifru_ivalue);
 
       //WEIGHT_WLAN_LOW,          /* <11Mb WLAN     */
       //WEIGHT_WLAN_11MB,         /* 11Mb 802.11b   */
@@ -908,23 +804,23 @@
       if (ioctl(olsr_cnf->ioctl_s, SIOCGMIIPHY, &ifr) < 0) {
 	if (errno != ENODEV)
 	  OLSR_PRINTF(1, "SIOCGMIIPHY on '%s' failed: %s\n",
-		      ifr.ifr_name, strerror(errno))
+		      ifr.ifr_name, strerror(errno));
 	return WEIGHT_ETHERNET_DEFAULT;
       }
 
       mii->reg_num = MII_BMCR;
       if (ioctl(olsr_cnf->ioctl_s, SIOCGMIIREG, &ifr) < 0) {
 	OLSR_PRINTF(1, "SIOCGMIIREG on %s failed: %s\n", ifr.ifr_name,
-		    strerror(errno))
+		    strerror(errno));
 	return WEIGHT_ETHERNET_DEFAULT;
       }
       bmcr = mii->val_out;
 
 
-      OLSR_PRINTF(1, "%s: ", ifr.ifr_name)
+      OLSR_PRINTF(1, "%s: ", ifr.ifr_name);
       OLSR_PRINTF(1, "%s Mbit, %s duplex\n",
 		  (bmcr & MII_BMCR_100MBIT) ? "100" : "10",
-		  (bmcr & MII_BMCR_DUPLEX) ? "full" : "half")
+		  (bmcr & MII_BMCR_DUPLEX) ? "full" : "half");
     
       is_if_link_up(ifname);
 
@@ -958,19 +854,19 @@
       if (ioctl(olsr_cnf->ioctl_s, SIOCGMIIPHY, &ifr) < 0) {
 	if (errno != ENODEV)
 	  OLSR_PRINTF(1, "SIOCGMIIPHY on '%s' failed: %s\n",
-		      ifr.ifr_name, strerror(errno))
+		      ifr.ifr_name, strerror(errno));
 	return WEIGHT_ETHERNET_DEFAULT;
       }
       mii->reg_num = MII_BMSR;
       if (ioctl(olsr_cnf->ioctl_s, SIOCGMIIREG, &ifr) < 0) {
 	OLSR_PRINTF(1, "SIOCGMIIREG on %s failed: %s\n", ifr.ifr_name,
-		    strerror(errno))
+		    strerror(errno));
 	return WEIGHT_ETHERNET_DEFAULT;
       }
       bmsr = mii->val_out;
 
-      OLSR_PRINTF(1, "%s: ", ifr.ifr_name)
-      OLSR_PRINTF(1, "%s\n", (bmsr & MII_BMSR_LINK_VALID) ? "link ok " : "no link ")
+      OLSR_PRINTF(1, "%s: ", ifr.ifr_name);
+      OLSR_PRINTF(1, "%s\n", (bmsr & MII_BMSR_LINK_VALID) ? "link ok " : "no link ");
     
       return (bmsr & MII_BMSR_LINK_VALID);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/local_hna_set.c olsrd-current/src/local_hna_set.c
--- olsrd-0.5.0/src/local_hna_set.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/local_hna_set.c	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: local_hna_set.c,v 1.12 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: local_hna_set.c,v 1.13 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -106,9 +106,9 @@
 int
 remove_local_hna6_entry(union olsr_ip_addr *net, olsr_u16_t prefix_len)
 {
-  struct hna6_entry *h6 = olsr_cnf->hna6_entries, *h6prev = NULL;
+  struct hna6_entry *h6, *h6prev = NULL;
 
-  while(h6)
+  for(h6 = olsr_cnf->hna6_entries; h6; h6 = h6->next)
     {
       if((memcmp(net, &h6->net, olsr_cnf->ipsize) == 0) && 
 	 (prefix_len == h6->prefix_len))
@@ -123,9 +123,7 @@
 	  return 1;
 	}
       h6prev = h6;
-      h6 = h6->next;
     }
-
   return 0;
 }
 
@@ -171,19 +169,16 @@
 
 
 int
-check_inet_gw()
+check_inet_gw(void)
 {
-  struct hna4_entry *h4 = olsr_cnf->hna4_entries;
-
   if(olsr_cnf->ip_version == AF_INET)
     {
-      while(h4)
+      struct hna4_entry *h4;
+      for(h4 = olsr_cnf->hna4_entries; h4; h4 = h4->next)
 	{
 	  if(h4->netmask.v4 == 0 && h4->net.v4 == 0)
 	    return 1;
-	  h4 = h4->next;
 	}
-      return 0;
     }
   return 0;
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/log.h olsrd-current/src/log.h
--- olsrd-0.5.0/src/log.h	2004-11-21 12:28:56.000000000 +0100
+++ olsrd-current/src/log.h	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: log.h,v 1.5 2004/11/21 11:28:56 kattemat Exp $
+ * $Id: log.h,v 1.6 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 /* 
@@ -55,7 +55,7 @@
 olsr_openlog(const char *ident);
 
 void
-olsr_syslog(int level, char *format, ...);
+olsr_syslog(int level, char *format, ...) __attribute__((format(printf,2,3)));
 
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/lq_avl.c olsrd-current/src/lq_avl.c
--- olsrd-0.5.0/src/lq_avl.c	2007-03-29 02:05:50.000000000 +0200
+++ olsrd-current/src/lq_avl.c	2007-04-20 16:23:41.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: lq_avl.c,v 1.8 2007/03/29 00:05:50 tlopatic Exp $
+ * $Id: lq_avl.c,v 1.9 2007/04/20 14:23:41 bernd67 Exp $
  */
 
 #include <stddef.h>
@@ -427,7 +427,7 @@
   post_delete(tree, parent->parent);
 }
 
-static inline struct avl_node *local_min(struct avl_node *node)
+static struct avl_node *local_min(struct avl_node *node)
 {
   while (node->left != NULL)
     node = node->left;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/lq_route.c olsrd-current/src/lq_route.c
--- olsrd-0.5.0/src/lq_route.c	2007-03-29 02:05:50.000000000 +0200
+++ olsrd-current/src/lq_route.c	2007-04-26 00:08:09.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: lq_route.c,v 1.45 2007/03/29 00:05:50 tlopatic Exp $
+ * $Id: lq_route.c,v 1.46 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -594,7 +594,7 @@
               nowtm->tm_hour,
               nowtm->tm_min,
               nowtm->tm_sec,
-              (int)now.tv_usec/10000)
+              (int)now.tv_usec/10000);
 
   for (node = list_get_next(node); node != NULL; node = list_get_next(node))
   {
@@ -609,7 +609,7 @@
          walker = walker->prev)
     {
       OLSR_PRINTF(2, "%s:%s <- ", olsr_ip_to_string(&walker->addr),
-                  etx_to_string(walker->path_etx))
+                  etx_to_string(walker->path_etx));
       hops++;
     }
 
@@ -618,7 +618,7 @@
     if (walker != NULL)
     {
       OLSR_PRINTF(2, "%s:%s (one-hop)\n", olsr_ip_to_string(&walker->addr),
-                  etx_to_string(walker->path_etx))
+                  etx_to_string(walker->path_etx));
 
       // node reachable => add to the set of unprocessed nodes
       // for HNA processing
@@ -628,7 +628,7 @@
 
     else
     {
-      OLSR_PRINTF(2, "%s FAILED\n", olsr_ip_to_string(&vert->addr))
+      OLSR_PRINTF(2, "%s FAILED\n", olsr_ip_to_string(&vert->addr));
       continue;
     }
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/main.c olsrd-current/src/main.c
--- olsrd-0.5.0/src/main.c	2007-02-24 12:54:24.000000000 +0100
+++ olsrd-current/src/main.c	2007-05-09 01:10:37.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: main.c,v 1.92 2007/02/24 11:54:24 kattemat Exp $
+ * $Id: main.c,v 1.96 2007/05/08 23:10:37 bernd67 Exp $
  */
 
 #include <unistd.h>
@@ -62,21 +62,21 @@
 
 #ifdef WIN32
 #define close(x) closesocket(x)
-int __stdcall SignalHandler(unsigned long signal);
+int __stdcall SignalHandler(unsigned long signal) __attribute__((noreturn));
 void ListInterfaces(void);
 void DisableIcmpRedirects(void);
 olsr_bool olsr_win32_end_request = OLSR_FALSE;
 olsr_bool olsr_win32_end_flag = OLSR_FALSE;
 #else
 static void
-olsr_shutdown(int);
+olsr_shutdown(int) __attribute__((noreturn));
 #endif
 
 /*
  * Local function prototypes
  */
 void
-olsr_reconfigure(int);
+olsr_reconfigure(int) __attribute__((noreturn));
 
 static void
 print_usage(void);
@@ -105,17 +105,17 @@
   char conf_file_name[FILENAME_MAX];
   struct tms tms_buf;
 
+#ifdef WIN32
+  WSADATA WsaData;
+  int len;
+#endif
+
   /* Stop the compiler from complaining */
   (void)copyright_string;
 
   debug_handle = stdout;
   olsr_argv = argv;
 
-#ifdef WIN32
-  WSADATA WsaData;
-  int len;
-#endif
-
   setbuf(stdout, NULL);
   setbuf(stderr, NULL);
 
@@ -301,7 +301,7 @@
     {
       if(apm_init() < 0)
 	{
-	  OLSR_PRINTF(1, "Could not read APM info - setting default willingness(%d)\n", WILL_DEFAULT)
+	  OLSR_PRINTF(1, "Could not read APM info - setting default willingness(%d)\n", WILL_DEFAULT);
 
 	  olsr_syslog(OLSR_LOG_ERR, "Could not read APM info - setting default willingness(%d)\n", WILL_DEFAULT);
 
@@ -312,19 +312,19 @@
 	{
 	  olsr_cnf->willingness = olsr_calculate_willingness();
 
-	  OLSR_PRINTF(1, "Willingness set to %d - next update in %.1f secs\n", olsr_cnf->willingness, olsr_cnf->will_int)
+	  OLSR_PRINTF(1, "Willingness set to %d - next update in %.1f secs\n", olsr_cnf->willingness, olsr_cnf->will_int);
 	}
     }
 
   /* Set ipsize */
   if(olsr_cnf->ip_version == AF_INET6)
     {
-      OLSR_PRINTF(1, "Using IP version 6\n")
+      OLSR_PRINTF(1, "Using IP version 6\n");
       olsr_cnf->ipsize = sizeof(struct in6_addr);
     }
   else
     {
-      OLSR_PRINTF(1, "Using IP version 4\n")
+      OLSR_PRINTF(1, "Using IP version 4\n");
       olsr_cnf->ipsize = sizeof(olsr_u32_t);
     }
 
@@ -380,7 +380,7 @@
   /* Load plugins */
   olsr_load_plugins();
 
-  OLSR_PRINTF(1, "Main address: %s\n\n", olsr_ip_to_string(&olsr_cnf->main_addr))
+  OLSR_PRINTF(1, "Main address: %s\n\n", olsr_ip_to_string(&olsr_cnf->main_addr));
 
   /* Start syslog entry */
   olsr_syslog(OLSR_LOG_INFO, "%s successfully started", SOFTWARE_VERSION);
@@ -407,9 +407,11 @@
   /* Starting scheduler */
   scheduler();
 
+  /* Stop the compiler from complaining */
+  (void)copyright_string;
+
   /* Like we're ever going to reach this ;-) */
   return 1;
-
 } /* main */
 
 
@@ -421,7 +423,7 @@
  */
 #ifndef WIN32
 void
-olsr_reconfigure(int signal)
+olsr_reconfigure(int signal __attribute__((unused)))
 {
   if(!fork())
     {
@@ -467,7 +469,7 @@
 
   olsr_delete_all_kernel_routes();
 
-  OLSR_PRINTF(1, "Closing sockets...\n")
+  OLSR_PRINTF(1, "Closing sockets...\n");
 
   /* front-end IPC socket */
   if(olsr_cnf->open_ipc)
@@ -493,7 +495,7 @@
 
   olsr_syslog(OLSR_LOG_INFO, "%s stopped", SOFTWARE_VERSION);
 
-  OLSR_PRINTF(1, "\n <<<< %s - terminating >>>>\n           http://www.olsr.org\n", SOFTWARE_VERSION)
+  OLSR_PRINTF(1, "\n <<<< %s - terminating >>>>\n           http://www.olsr.org\n", SOFTWARE_VERSION);
 
   exit(olsr_cnf->exit_value);
 }
@@ -502,18 +504,19 @@
  * Print the command line usage
  */
 static void
-print_usage()
+print_usage(void)
 {
 
-  fprintf(stderr, "An error occured somewhere between your keyboard and your chair!\n"); 
-  fprintf(stderr, "usage: olsrd [-f <configfile>] [ -i interface1 interface2 ... ]\n");
-  fprintf(stderr, "  [-d <debug_level>] [-ipv6] [-multi <IPv6 multicast address>]\n"); 
-  fprintf(stderr, "  [-lql <LQ level>] [-lqw <LQ winsize>]\n"); 
-  fprintf(stderr, "  [-bcast <broadcastaddr>] [-ipc] [-dispin] [-dispout] [-delgw]\n");
-  fprintf(stderr, "  [-hint <hello interval (secs)>] [-tcint <tc interval (secs)>]\n");
-  fprintf(stderr, "  [-midint <mid interval (secs)>] [-hnaint <hna interval (secs)>]\n");
-  fprintf(stderr, "  [-T <Polling Rate (secs)>] [-nofork] [-hemu <ip_address>] \n"); 
-  fprintf(stderr, "  [-lql <LQ level>] [-lqw <LQ winsize>]\n");
+  fprintf(stderr,
+          "An error occured somwhere between your keyboard and your chair!\n"
+          "usage: olsrd [-f <configfile>] [ -i interface1 interface2 ... ]\n"
+          "  [-d <debug_level>] [-ipv6] [-multi <IPv6 multicast address>]\n"
+          "  [-lql <LQ level>] [-lqw <LQ winsize>]\n"
+          "  [-bcast <broadcastaddr>] [-ipc] [-dispin] [-dispout] [-delgw]\n"
+          "  [-hint <hello interval (secs)>] [-tcint <tc interval (secs)>]\n"
+          "  [-midint <mid interval (secs)>] [-hnaint <hna interval (secs)>]\n"
+          "  [-T <Polling Rate (secs)>] [-nofork] [-hemu <ip_address>]\n"
+          "  [-lql <LQ level>] [-lqw <LQ winsize>]\n");
 }
 
 
@@ -789,7 +792,7 @@
 	  struct in6_addr in6;
 	  NEXT_ARG;
           CHECK_ARGC;
-	  if(inet_pton(AF_INET6, *argv, &in6) < 0)
+	  if(inet_pton(AF_INET6, *argv, &in6) <= 0)
 	    {
 	      fprintf(stderr, "Failed converting IP address %s\n", *argv);
 	      exit(EXIT_FAILURE);
@@ -810,7 +813,7 @@
       
 	  NEXT_ARG;
           CHECK_ARGC;
-	  if(inet_pton(AF_INET, *argv, &in) < 0)
+	  if(inet_pton(AF_INET, *argv, &in) <= 0)
 	    {
 	      fprintf(stderr, "Failed converting IP address %s\n", *argv);
 	      exit(EXIT_FAILURE);
